package de.web.minecraftandi;

import java.io.*;
import java.util.Scanner;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

import org.bukkit.plugin.PluginDescriptionFile;

public class xDataManager {
    private static xLevel plugin;
	private static final String dataFolder = "plugins/xLevel/players/";
	private static double lastTimeSaved = System.currentTimeMillis();
	public static ConcurrentHashMap<String, String> playerDatas = new ConcurrentHashMap<String, String>();
	
    public static void startup(final xLevel plugin) {
        xDataManager.plugin = plugin;
    }
	
	public static void initialize() {
		File dataFolder2 = new File(dataFolder);
        if(!dataFolder2.exists()) {
            dataFolder2.mkdirs();
        }
	}
	
	public static void NewEntry(String playername) {
		if (!playerDatas.containsKey(playername)) {
			playerDatas.put(playername, "Commoner 0 0");
		}
	}
	
	public static void loadData() {
		File folder = new File(dataFolder);
		File[] fileList = folder.listFiles();
		
		PluginDescriptionFile pdfFile = plugin.getDescription();
		System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] loading playerdata..." );
    	
		int entries = 0;
		
		for (int i = 0; i < fileList.length; i++) {
			String fileName = fileList[i].getName();
			String[] split = fileName.split("\\.");
			if (split.length == 2) {
				if (fileName.endsWith(".playerdata") || fileName.endsWith(".PLAYERDATA")) {
					try {
						Scanner scan = new Scanner(fileList[i]);
						String playerData = "none";
						if (scan.hasNextLine()) {
							playerData = scan.nextLine();
				        }
				        scan.close();
				        if (!playerData.equalsIgnoreCase("none")) {
				        	playerDatas.put(split[0], playerData);
				        	entries++;
				        }
					} catch(IOException ex) {
						ex.printStackTrace();
					}
				}
			}
		}
		
		System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] loaded " + entries + " playerdata entries!" );
	}
	
	public static String getData(String playername) {
		if (playerDatas.containsKey(playername)) {
			return (String)playerDatas.get(playername);
		}
		return "none";
	}
	
	public static void setData(String playername, String playerDataSet) {
		playerDatas.put(playername, playerDataSet);
	}
	
	public static void resetAll(String playername) {
		playerDatas.put(playername, "Commoner 0 0");
	}
	
	public static void saveData() {
		Set<String> keys = playerDatas.keySet();
		String[] strKeys = keys.toArray(new String[keys.size()]);
		
		int entries = 0;
		
		for (int i = 0; i < strKeys.length; i++) {
			if (playerDatas.containsKey(strKeys[i])) {
				try {
					File dataFile = new File(dataFolder + strKeys[i] + ".PLAYERDATA");
			        
		        	dataFile.createNewFile();
			        FileWriter fw = new FileWriter(dataFile);
	        		fw.write(playerDatas.get(strKeys[i]));
	        		fw.close();
	        		entries++;
				} catch(IOException ex) {
					ex.printStackTrace();
				}
			}
		}
		
		PluginDescriptionFile pdfFile = plugin.getDescription();
		if (xConfig.logSaving) {
			System.out.println("[" + pdfFile.getName() + "] version [" + pdfFile.getVersion() + "] saved " + entries + " playerdata entries!" );
		}
	}

	public static void checkSaveData() {
		double now = System.currentTimeMillis();
		double timeDiverse = now - lastTimeSaved;
		
		if (timeDiverse >= (double)(xConfig.saveInterval*1000)) {
			lastTimeSaved = System.currentTimeMillis();
			saveData();
		}
	}
}
